//small library to help fast and loose glProgramming
//lets you do opperations on the float 3 vectors and
//the colum major matrix representations used so much by openGl.
//unfortalty, these functions are ment for simplicity and speed, not
//type or memory protection, so be carful with them.

#ifndef NEHE_MATH_H
#define NEHE_MATH_H


#include <win_globals.h>

#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library
#include <stdarg.h>			// Header File For Variable Argument Routines
#include <sven.h>

namespace gl_ex {

using namespace sven;

inline void glColor(const rgba &color) { glColor4ub(color.r,color.g,color.b,color.a); }
inline void glTranslatefv(float *v) { glTranslatef(v[0],v[1],v[2]); }
inline void glTranslatef3(float3 v) { glTranslatef(v[0],v[1],v[2]); }

//handy function to have around (tm)
//almost should have been built into opengl
//much more general than sgg's glPick function.
//Also slightly slower and harder to use.
//x and y are the screen positions that you want to pick at.
//drawItems is a function that does all the pickable object drawing,
//and that is assumed to call glLoadName at all the right times.
//mm is the modelview matrix that use want to use (if NULL you
//end up using the current matrix)
//the return value is the integer name assosiated with whatever
//pick was found (or -1 if you didn't hit anything)
int glSelect(GLdouble x, GLdouble y, void_fun drawItems, GLfloat *mm=NULL);

void glRasterObjPos(GLdouble * o_pos);


void copy4x4(float * m1, float * m2);
void mult4x4(float * m1, float * m2, float * rval);
inline void multEQ(float * dest, float * m) {
	GLfloat old[16];
	copy4x4(dest,old);
	mult4x4(m,old,dest);
}
inline void multEQ2(float * dest, float * m) {
	GLfloat old[16];
	copy4x4(dest,old);
	mult4x4(old,m,dest);
}

void identity4x4(float * m);
void print4x4(const char * fname, float * m);

//operations for float[3] variables
void cross(float * v1, float * v2, float * rval);
void dif(float * v1, float * v2, float * rval);
void nCross(float * v1, float * v2, float * rval);

//Stuff that also uses my float3 class

//req float[16] (if you use this libary, don't use this one acidently....)
float3 operator *(float * a, float3 b);

//Modifies opengl's current matrix with a cordTransform
void cordTransform(float3 i,float3 j,float3 k);
void invCordTransform(float3 i,float3 j,float3 k);

void translateMatrix(float x, float y, float z, float * rval);
inline float16 translationMatrix(float x, float y, float z) {
	float16 rval;
	translateMatrix(x,y,z,rval.m);
	return rval;
}
inline float16 translationMatrix(float3 t) { return translationMatrix(t[0],t[1],t[2]); }
void translateMatrix(float3 t, float * rval);
void cordTransformMatrix(float3 i,float3 j,float3 k, float * r);
void invCTransformMatrix(float3 i,float3 j,float3 k, float * r);


void glPushMaterialDif();
void glPopMaterialDif();
void glMaterialDif(float r, float g, float b, float w = 1.0f);

void glPrintMatrix();

void gl_rotation_matrix( GLfloat angle, GLfloat x, GLfloat y, GLfloat z,
                         GLfloat m[] );

inline void gl_rotation_matrix( GLfloat angle, float3 a, GLfloat m[] ) {
	gl_rotation_matrix(angle,a[0],a[1],a[2],m);
}

inline float16 gl_rotation_float16( GLfloat angle, GLfloat x, GLfloat y, GLfloat z) {
	float16 rval;
	gl_rotation_matrix(angle,x,y,z,rval.m);
	return rval;
}

void rectDList(GLuint * dList, GLuint texture, float w, float h);
void rectAlphaDList(GLuint * dList, GLuint texture, float w, float h);
void rectC4DList(GLuint * dList, GLubyte r, GLubyte g, GLubyte b, GLubyte a, float w, float h);

}

#endif