#include "std_precomp.h"
#include <wx/bitmap.h>
#include <ifl/iflFile.h>
//#include <memory.h>


void ifl_make_bitmap(const char * fname, unsigned char * data, iflSize dims) {
	iflSize save_dims(dims.x, dims.y, 3);
	unsigned char *save_data = (dims.c==3) ? data : 
							new unsigned char[save_dims.x*save_dims.y*save_dims.c];
	
	switch(dims.c) {
	case 3:
		break;

	case 4:
		{for(int i=0;i<save_dims.x*save_dims.y;i++) {
			save_data[i*save_dims.c]=data[i*dims.c];
			save_data[i*save_dims.c+1]=data[i*dims.c+1];
			save_data[i*save_dims.c+2]=data[i*dims.c+2];
		}}
		break;

	case 2:
	case 1:
		{for(int i=0;i<save_dims.x*save_dims.y;i++) {
			save_data[i*save_dims.c]=data[i*dims.c];
			save_data[i*save_dims.c+1]=data[i*dims.c];
			save_data[i*save_dims.c+2]=data[i*dims.c];
		}}
		break;
	}

	iflFileConfig fc(&save_dims, iflUChar);
	iflStatus sts;
	iflFile* file = iflFile::create(fname, NULL, &fc, NULL, &sts);
	if (sts != iflOKAY) { //throw image_create_error(); 
	}

	// write a page data to file
	sts= file->setPage(save_data, 0, 0, 0, 3, save_dims.x, save_dims.y, 1, 3);
	if (sts != iflOKAY) { //image_setPage_error();
	}

	file->close();
	if(dims.c!=3) delete save_data;	
}

//In a perfect world, this would work:
//wxBitmap rval = wxBitmap(data, dims.x, dims.y,dims.c);

//but we are not so lucky, so we have to do this silly thing.
wxBitmap messy_hack(unsigned char * data, iflSize dims) {
	ifl_make_bitmap("ifl_hack_temp.bmp", data,dims);
	wxBitmap rval = wxBitmap("ifl_hack_temp.bmp",wxBITMAP_TYPE_BMP);
	DeleteFile("ifl_hack_temp.bmp");
	return rval;

}

wxBitmap iflBitmap(const char * fname) {
	iflStatus sts;
    iflFile* file = iflFile::open(fname, O_RDONLY, &sts);
    if (sts != iflOKAY) { 
		//throw nehe_error::image_open_failed(fname);
	}


    iflSize dims;
    file->getDimensions(dims);
    unsigned char* data = new unsigned char[dims.x*dims.y*dims.c];

    iflConfig cfg(iflUChar, iflInterleaved);
    sts = file->getTile(0, 0, 0, dims.x, dims.y, 1, data, &cfg);
    if (sts != iflOKAY) { /* handle error */ }
	
	wxBitmap rval = messy_hack(data,dims);
	delete data;

	return rval;
}