#include <sven.h>

namespace sven {

const Float_Rect Float_Rect::null(0,0,0,0);

Float_Rect convert(const Float2_Polygon & p) {
	using namespace std_ex;
	if(p.size()!=4) return Float_Rect::null;
	float tx=p[0].x, ty=p[0].y, bx=p[0].x, by=p[0].y;
	bool newx=false, newy=false;
	for(int i=1;i<4;i++) {
		if(p[i].x!=bx && p[i].x!=tx ) {
			if(newx) return Float_Rect::null;
			newx=true;
			tx=p[i].x;
		}
		if(p[i].y!=by && p[i].y!=ty) {
			if(newy) return Float_Rect::null;
			newy=true;
			ty=p[i].y;
		}
	}
	if(!(newx && newy)) return  Float_Rect::null;
	if(ty<by) std::swap(ty,by);
	if(tx>bx) std::swap(tx,bx);
	return Float_Rect(tx,ty,bx,by);
}

}